#ifndef SBK_KCountryFlagEmojiIconEngineWrapper_H
#define SBK_KCountryFlagEmojiIconEngineWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <kcountryflagemojiiconengine.h>

class KCountryFlagEmojiIconEngineWrapper : public KCountryFlagEmojiIconEngine
{
public:
    KCountryFlagEmojiIconEngineWrapper(const KCountryFlagEmojiIconEngineWrapper &) = delete;
    KCountryFlagEmojiIconEngineWrapper& operator=(const KCountryFlagEmojiIconEngineWrapper &) = delete;
    KCountryFlagEmojiIconEngineWrapper(KCountryFlagEmojiIconEngineWrapper &&) = delete;
    KCountryFlagEmojiIconEngineWrapper& operator=(KCountryFlagEmojiIconEngineWrapper &&) = delete;

    KCountryFlagEmojiIconEngineWrapper(const ::QString & regionOrCountry);
    ::QSize actualSize(const ::QSize & size, ::QIcon::Mode mode, ::QIcon::State state) override;
    void addFile(const ::QString & fileName, const ::QSize & size, ::QIcon::Mode mode, ::QIcon::State state) override;
    void addPixmap(const ::QPixmap & pixmap, ::QIcon::Mode mode, ::QIcon::State state) override;
    ::QList<QSize> availableSizes(::QIcon::Mode mode = QIcon::Normal, ::QIcon::State state = QIcon::Off) override;
    ::QIconEngine * clone() const override;
    ::QString iconName() override;
    bool isNull() override;
    ::QString key() const override;
    void paint(::QPainter * painter, const ::QRect & rect, ::QIcon::Mode mode, ::QIcon::State state) override;
    ::QPixmap pixmap(const ::QSize & size, ::QIcon::Mode mode, ::QIcon::State state) override;
    bool read(::QDataStream & in) override;
    ::QPixmap scaledPixmap(const ::QSize & size, ::QIcon::Mode mode, ::QIcon::State state, qreal scale) override;
    bool write(::QDataStream & out) const override;
    ~KCountryFlagEmojiIconEngineWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[13] = {false, false, false, false, false, false, false, false, false, false, false, false, false};
};

#endif // SBK_KCountryFlagEmojiIconEngineWrapper_H

